Package org.apache.commons.dbutils

## Class BaseResultSetHandler<T>

- java.lang.Object
- - org.apache.commons.dbutils.BaseResultSetHandler<T>

- Type Parameters:
    `T` - the target type the input ResultSet will be converted to.
  All Implemented Interfaces:
    `ResultSetHandler<T>`

      public abstract class BaseResultSetHandler<T>
      extends Object
      implements ResultSetHandler<T>

  Extensions of this class convert ResultSets into other objects. According to the DRY principle (Don't Repeat Yourself), repeating `resultSet` variable inside the `ResultSetHandler.handle(ResultSet)` over and over for each iteration can get a little tedious, `AbstractResultSetHandler` implicitly gives users access to `ResultSet`'s methods. NOTE This class is NOT thread safe!
  Since:
    1.6

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BaseResultSetHandler()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected boolean` | `absolute​(int row)`
    `protected void` | `afterLast()`
    `protected void` | `beforeFirst()`
    `protected void` | `cancelRowUpdates()`
    `protected void` | `clearWarnings()`
    `protected void` | `close()`
    `protected void` | `deleteRow()`
    `protected int` | `findColumn​(String columnLabel)`
    `protected boolean` | `first()`
    `protected ResultSet` | `getAdaptedResultSet()` |
    `protected Array` | `getArray​(int columnIndex)`
    `protected Array` | `getArray​(String columnLabel)`
    `protected InputStream` | `getAsciiStream​(int columnIndex)`
    `protected InputStream` | `getAsciiStream​(String columnLabel)`
    `protected BigDecimal` | `getBigDecimal​(int columnIndex)`
    `protected BigDecimal` | `getBigDecimal​(int columnIndex, int scale)` | Deprecated.
    `protected BigDecimal` | `getBigDecimal​(String columnLabel)`
    `protected BigDecimal` | `getBigDecimal​(String columnLabel, int scale)` | Deprecated.
    `protected InputStream` | `getBinaryStream​(int columnIndex)`
    `protected InputStream` | `getBinaryStream​(String columnLabel)`
    `protected Blob` | `getBlob​(int columnIndex)`
    `protected Blob` | `getBlob​(String columnLabel)`
    `protected boolean` | `getBoolean​(int columnIndex)`
    `protected boolean` | `getBoolean​(String columnLabel)`
    `protected byte` | `getByte​(int columnIndex)`
    `protected byte` | `getByte​(String columnLabel)`
    `protected byte[]` | `getBytes​(int columnIndex)`
    `protected byte[]` | `getBytes​(String columnLabel)`
    `protected Reader` | `getCharacterStream​(int columnIndex)`
    `protected Reader` | `getCharacterStream​(String columnLabel)`
    `protected Clob` | `getClob​(int columnIndex)`
    `protected Clob` | `getClob​(String columnLabel)`
    `protected int` | `getConcurrency()`
    `protected String` | `getCursorName()`
    `protected Date` | `getDate​(int columnIndex)`
    `protected Date` | `getDate​(int columnIndex, Calendar cal)`
    `protected Date` | `getDate​(String columnLabel)`
    `protected Date` | `getDate​(String columnLabel, Calendar cal)`
    `protected double` | `getDouble​(int columnIndex)`
    `protected double` | `getDouble​(String columnLabel)`
    `protected int` | `getFetchDirection()`
    `protected int` | `getFetchSize()`
    `protected float` | `getFloat​(int columnIndex)`
    `protected float` | `getFloat​(String columnLabel)`
    `protected int` | `getHoldability()`
    `protected int` | `getInt​(int columnIndex)`
    `protected int` | `getInt​(String columnLabel)`
    `protected long` | `getLong​(int columnIndex)`
    `protected long` | `getLong​(String columnLabel)`
    `protected ResultSetMetaData` | `getMetaData()`
    `protected Reader` | `getNCharacterStream​(int columnIndex)`
    `protected Reader` | `getNCharacterStream​(String columnLabel)`
    `protected NClob` | `getNClob​(int columnIndex)`
    `protected NClob` | `getNClob​(String columnLabel)`
    `protected String` | `getNString​(int columnIndex)`
    `protected String` | `getNString​(String columnLabel)`
    `protected Object` | `getObject​(int columnIndex)`
    `protected Object` | `getObject​(int columnIndex, Map<String,​Class<?>> map)`
    `protected Object` | `getObject​(String columnLabel)`
    `protected Object` | `getObject​(String columnLabel, Map<String,​Class<?>> map)`
    `protected Ref` | `getRef​(int columnIndex)`
    `protected Ref` | `getRef​(String columnLabel)`
    `protected int` | `getRow()`
    `protected RowId` | `getRowId​(int columnIndex)`
    `protected RowId` | `getRowId​(String columnLabel)`
    `protected short` | `getShort​(int columnIndex)`
    `protected short` | `getShort​(String columnLabel)`
    `protected SQLXML` | `getSQLXML​(int columnIndex)`
    `protected SQLXML` | `getSQLXML​(String columnLabel)`
    `protected Statement` | `getStatement()`
    `protected String` | `getString​(int columnIndex)`
    `protected String` | `getString​(String columnLabel)`
    `protected Time` | `getTime​(int columnIndex)`
    `protected Time` | `getTime​(int columnIndex, Calendar cal)`
    `protected Time` | `getTime​(String columnLabel)`
    `protected Time` | `getTime​(String columnLabel, Calendar cal)`
    `protected Timestamp` | `getTimestamp​(int columnIndex)`
    `protected Timestamp` | `getTimestamp​(int columnIndex, Calendar cal)`
    `protected Timestamp` | `getTimestamp​(String columnLabel)`
    `protected Timestamp` | `getTimestamp​(String columnLabel, Calendar cal)`
    `protected int` | `getType()`
    `protected InputStream` | `getUnicodeStream​(int columnIndex)` | Deprecated.
    `protected InputStream` | `getUnicodeStream​(String columnLabel)` | Deprecated.
    `protected URL` | `getURL​(int columnIndex)`
    `protected URL` | `getURL​(String columnLabel)`
    `protected SQLWarning` | `getWarnings()`
    `protected abstract T` | `handle()` | Turn the `ResultSet` into an Object.
    `T` | `handle​(ResultSet rs)` | Turn the `ResultSet` into an Object.
    `protected void` | `insertRow()`
    `protected boolean` | `isAfterLast()`
    `protected boolean` | `isBeforeFirst()`
    `protected boolean` | `isClosed()`
    `protected boolean` | `isFirst()`
    `protected boolean` | `isLast()`
    `protected boolean` | `isWrapperFor​(Class<?> iface)`
    `protected boolean` | `last()`
    `protected void` | `moveToCurrentRow()`
    `protected void` | `moveToInsertRow()`
    `protected boolean` | `next()`
    `protected boolean` | `previous()`
    `protected void` | `refreshRow()`
    `protected boolean` | `relative​(int rows)`
    `protected boolean` | `rowDeleted()`
    `protected boolean` | `rowInserted()`
    `protected boolean` | `rowUpdated()`
    `protected void` | `setFetchDirection​(int direction)`
    `protected void` | `setFetchSize​(int rows)`
    `protected <E> E` | `unwrap​(Class<E> iface)`
    `protected void` | `updateArray​(int columnIndex, Array x)`
    `protected void` | `updateArray​(String columnLabel, Array x)`
    `protected void` | `updateAsciiStream​(int columnIndex, InputStream x)`
    `protected void` | `updateAsciiStream​(int columnIndex, InputStream x, int length)`
    `protected void` | `updateAsciiStream​(int columnIndex, InputStream x, long length)`
    `protected void` | `updateAsciiStream​(String columnLabel, InputStream x)`
    `protected void` | `updateAsciiStream​(String columnLabel, InputStream x, int length)`
    `protected void` | `updateAsciiStream​(String columnLabel, InputStream x, long length)`
    `protected void` | `updateBigDecimal​(int columnIndex, BigDecimal x)`
    `protected void` | `updateBigDecimal​(String columnLabel, BigDecimal x)`
    `protected void` | `updateBinaryStream​(int columnIndex, InputStream x)`
    `protected void` | `updateBinaryStream​(int columnIndex, InputStream x, int length)`
    `protected void` | `updateBinaryStream​(int columnIndex, InputStream x, long length)`
    `protected void` | `updateBinaryStream​(String columnLabel, InputStream x)`
    `protected void` | `updateBinaryStream​(String columnLabel, InputStream x, int length)`
    `protected void` | `updateBinaryStream​(String columnLabel, InputStream x, long length)`
    `protected void` | `updateBlob​(int columnIndex, InputStream inputStream)`
    `protected void` | `updateBlob​(int columnIndex, InputStream inputStream, long length)`
    `protected void` | `updateBlob​(int columnIndex, Blob x)`
    `protected void` | `updateBlob​(String columnLabel, InputStream inputStream)`
    `protected void` | `updateBlob​(String columnLabel, InputStream inputStream, long length)`
    `protected void` | `updateBlob​(String columnLabel, Blob x)`
    `protected void` | `updateBoolean​(int columnIndex, boolean x)`
    `protected void` | `updateBoolean​(String columnLabel, boolean x)`
    `protected void` | `updateByte​(int columnIndex, byte x)`
    `protected void` | `updateByte​(String columnLabel, byte x)`
    `protected void` | `updateBytes​(int columnIndex, byte[] x)`
    `protected void` | `updateBytes​(String columnLabel, byte[] x)`
    `protected void` | `updateCharacterStream​(int columnIndex, Reader x)`
    `protected void` | `updateCharacterStream​(int columnIndex, Reader x, int length)`
    `protected void` | `updateCharacterStream​(int columnIndex, Reader x, long length)`
    `protected void` | `updateCharacterStream​(String columnLabel, Reader reader)`
    `protected void` | `updateCharacterStream​(String columnLabel, Reader reader, int length)`
    `protected void` | `updateCharacterStream​(String columnLabel, Reader reader, long length)`
    `protected void` | `updateClob​(int columnIndex, Reader reader)`
    `protected void` | `updateClob​(int columnIndex, Reader reader, long length)`
    `protected void` | `updateClob​(int columnIndex, Clob x)`
    `protected void` | `updateClob​(String columnLabel, Reader reader)`
    `protected void` | `updateClob​(String columnLabel, Reader reader, long length)`
    `protected void` | `updateClob​(String columnLabel, Clob x)`
    `protected void` | `updateDate​(int columnIndex, Date x)`
    `protected void` | `updateDate​(String columnLabel, Date x)`
    `protected void` | `updateDouble​(int columnIndex, double x)`
    `protected void` | `updateDouble​(String columnLabel, double x)`
    `protected void` | `updateFloat​(int columnIndex, float x)`
    `protected void` | `updateFloat​(String columnLabel, float x)`
    `protected void` | `updateInt​(int columnIndex, int x)`
    `protected void` | `updateInt​(String columnLabel, int x)`
    `protected void` | `updateLong​(int columnIndex, long x)`
    `protected void` | `updateLong​(String columnLabel, long x)`
    `protected void` | `updateNCharacterStream​(int columnIndex, Reader x)`
    `protected void` | `updateNCharacterStream​(int columnIndex, Reader x, long length)`
    `protected void` | `updateNCharacterStream​(String columnLabel, Reader reader)`
    `protected void` | `updateNCharacterStream​(String columnLabel, Reader reader, long length)`
    `protected void` | `updateNClob​(int columnIndex, Reader reader)`
    `protected void` | `updateNClob​(int columnIndex, Reader reader, long length)`
    `protected void` | `updateNClob​(int columnIndex, NClob nClob)`
    `protected void` | `updateNClob​(String columnLabel, Reader reader)`
    `protected void` | `updateNClob​(String columnLabel, Reader reader, long length)`
    `protected void` | `updateNClob​(String columnLabel, NClob nClob)`
    `protected void` | `updateNString​(int columnIndex, String nString)`
    `protected void` | `updateNString​(String columnLabel, String nString)`
    `protected void` | `updateNull​(int columnIndex)`
    `protected void` | `updateNull​(String columnLabel)`
    `protected void` | `updateObject​(int columnIndex, Object x)`
    `protected void` | `updateObject​(int columnIndex, Object x, int scaleOrLength)`
    `protected void` | `updateObject​(String columnLabel, Object x)`
    `protected void` | `updateObject​(String columnLabel, Object x, int scaleOrLength)`
    `protected void` | `updateRef​(int columnIndex, Ref x)`
    `protected void` | `updateRef​(String columnLabel, Ref x)`
    `protected void` | `updateRow()`
    `protected void` | `updateRowId​(int columnIndex, RowId x)`
    `protected void` | `updateRowId​(String columnLabel, RowId x)`
    `protected void` | `updateShort​(int columnIndex, short x)`
    `protected void` | `updateShort​(String columnLabel, short x)`
    `protected void` | `updateSQLXML​(int columnIndex, SQLXML xmlObject)`
    `protected void` | `updateSQLXML​(String columnLabel, SQLXML xmlObject)`
    `protected void` | `updateString​(int columnIndex, String x)`
    `protected void` | `updateString​(String columnLabel, String x)`
    `protected void` | `updateTime​(int columnIndex, Time x)`
    `protected void` | `updateTime​(String columnLabel, Time x)`
    `protected void` | `updateTimestamp​(int columnIndex, Timestamp x)`
    `protected void` | `updateTimestamp​(String columnLabel, Timestamp x)`
    `protected boolean` | `wasNull()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BaseResultSetHandler

          public BaseResultSetHandler()

  - ### Method Detail

    - #### absolute

          protected final boolean absolute​(int row)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### afterLast

          protected final void afterLast()
                                  throws SQLException

      Throws:
        `SQLException`

    - #### beforeFirst

          protected final void beforeFirst()
                                    throws SQLException

      Throws:
        `SQLException`

    - #### cancelRowUpdates

          protected final void cancelRowUpdates()
                                         throws SQLException

      Throws:
        `SQLException`

    - #### clearWarnings

          protected final void clearWarnings()
                                      throws SQLException

      Throws:
        `SQLException`

    - #### close

          protected final void close()
                              throws SQLException

      Throws:
        `SQLException`

    - #### deleteRow

          protected final void deleteRow()
                                  throws SQLException

      Throws:
        `SQLException`

    - #### findColumn

          protected final int findColumn​(String columnLabel)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### first

          protected final boolean first()
                                 throws SQLException

      Throws:
        `SQLException`

    - #### getAdaptedResultSet

          protected final ResultSet getAdaptedResultSet()

    - #### getArray

          protected final Array getArray​(int columnIndex)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getArray

          protected final Array getArray​(String columnLabel)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getAsciiStream

          protected final InputStream getAsciiStream​(int columnIndex)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### getAsciiStream

          protected final InputStream getAsciiStream​(String columnLabel)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### getBigDecimal

          protected final BigDecimal getBigDecimal​(int columnIndex)
                                            throws SQLException

      Throws:
        `SQLException`

    - #### getBigDecimal

          @Deprecated
          protected final BigDecimal getBigDecimal​(int columnIndex,
                                                   int scale)
                                            throws SQLException

      Deprecated.
      Throws:
        `SQLException`

    - #### getBigDecimal

          protected final BigDecimal getBigDecimal​(String columnLabel)
                                            throws SQLException

      Throws:
        `SQLException`

    - #### getBigDecimal

          @Deprecated
          protected final BigDecimal getBigDecimal​(String columnLabel,
                                                   int scale)
                                            throws SQLException

      Deprecated.
      Throws:
        `SQLException`

    - #### getBinaryStream

          protected final InputStream getBinaryStream​(int columnIndex)
                                               throws SQLException

      Throws:
        `SQLException`

    - #### getBinaryStream

          protected final InputStream getBinaryStream​(String columnLabel)
                                               throws SQLException

      Throws:
        `SQLException`

    - #### getBlob

          protected final Blob getBlob​(int columnIndex)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getBlob

          protected final Blob getBlob​(String columnLabel)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getBoolean

          protected final boolean getBoolean​(int columnIndex)
                                      throws SQLException

      Throws:
        `SQLException`

    - #### getBoolean

          protected final boolean getBoolean​(String columnLabel)
                                      throws SQLException

      Throws:
        `SQLException`

    - #### getByte

          protected final byte getByte​(int columnIndex)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getByte

          protected final byte getByte​(String columnLabel)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getBytes

          protected final byte[] getBytes​(int columnIndex)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### getBytes

          protected final byte[] getBytes​(String columnLabel)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### getCharacterStream

          protected final Reader getCharacterStream​(int columnIndex)
                                             throws SQLException

      Throws:
        `SQLException`

    - #### getCharacterStream

          protected final Reader getCharacterStream​(String columnLabel)
                                             throws SQLException

      Throws:
        `SQLException`

    - #### getClob

          protected final Clob getClob​(int columnIndex)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getClob

          protected final Clob getClob​(String columnLabel)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getConcurrency

          protected final int getConcurrency()
                                      throws SQLException

      Throws:
        `SQLException`

    - #### getCursorName

          protected final String getCursorName()
                                        throws SQLException

      Throws:
        `SQLException`

    - #### getDate

          protected final Date getDate​(int columnIndex)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getDate

          protected final Date getDate​(int columnIndex,
                                       Calendar cal)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getDate

          protected final Date getDate​(String columnLabel)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getDate

          protected final Date getDate​(String columnLabel,
                                       Calendar cal)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getDouble

          protected final double getDouble​(int columnIndex)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getDouble

          protected final double getDouble​(String columnLabel)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getFetchDirection

          protected final int getFetchDirection()
                                         throws SQLException

      Throws:
        `SQLException`

    - #### getFetchSize

          protected final int getFetchSize()
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getFloat

          protected final float getFloat​(int columnIndex)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getFloat

          protected final float getFloat​(String columnLabel)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getHoldability

          protected final int getHoldability()
                                      throws SQLException

      Throws:
        `SQLException`

    - #### getInt

          protected final int getInt​(int columnIndex)
                              throws SQLException

      Throws:
        `SQLException`

    - #### getInt

          protected final int getInt​(String columnLabel)
                              throws SQLException

      Throws:
        `SQLException`

    - #### getLong

          protected final long getLong​(int columnIndex)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getLong

          protected final long getLong​(String columnLabel)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getMetaData

          protected final ResultSetMetaData getMetaData()
                                                 throws SQLException

      Throws:
        `SQLException`

    - #### getNCharacterStream

          protected final Reader getNCharacterStream​(int columnIndex)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### getNCharacterStream

          protected final Reader getNCharacterStream​(String columnLabel)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### getNClob

          protected final NClob getNClob​(int columnIndex)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getNClob

          protected final NClob getNClob​(String columnLabel)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getNString

          protected final String getNString​(int columnIndex)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### getNString

          protected final String getNString​(String columnLabel)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### getObject

          protected final Object getObject​(int columnIndex)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getObject

          protected final Object getObject​(int columnIndex,
                                           Map<String,​Class<?>> map)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getObject

          protected final Object getObject​(String columnLabel)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getObject

          protected final Object getObject​(String columnLabel,
                                           Map<String,​Class<?>> map)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getRef

          protected final Ref getRef​(int columnIndex)
                              throws SQLException

      Throws:
        `SQLException`

    - #### getRef

          protected final Ref getRef​(String columnLabel)
                              throws SQLException

      Throws:
        `SQLException`

    - #### getRow

          protected final int getRow()
                              throws SQLException

      Throws:
        `SQLException`

    - #### getRowId

          protected final RowId getRowId​(int columnIndex)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getRowId

          protected final RowId getRowId​(String columnLabel)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getShort

          protected final short getShort​(int columnIndex)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getShort

          protected final short getShort​(String columnLabel)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### getSQLXML

          protected final SQLXML getSQLXML​(int columnIndex)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getSQLXML

          protected final SQLXML getSQLXML​(String columnLabel)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getStatement

          protected final Statement getStatement()
                                          throws SQLException

      Throws:
        `SQLException`

    - #### getString

          protected final String getString​(int columnIndex)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getString

          protected final String getString​(String columnLabel)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### getTime

          protected final Time getTime​(int columnIndex)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getTime

          protected final Time getTime​(int columnIndex,
                                       Calendar cal)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getTime

          protected final Time getTime​(String columnLabel)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getTime

          protected final Time getTime​(String columnLabel,
                                       Calendar cal)
                                throws SQLException

      Throws:
        `SQLException`

    - #### getTimestamp

          protected final Timestamp getTimestamp​(int columnIndex)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### getTimestamp

          protected final Timestamp getTimestamp​(int columnIndex,
                                                 Calendar cal)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### getTimestamp

          protected final Timestamp getTimestamp​(String columnLabel)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### getTimestamp

          protected final Timestamp getTimestamp​(String columnLabel,
                                                 Calendar cal)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### getType

          protected final int getType()
                               throws SQLException

      Throws:
        `SQLException`

    - #### getUnicodeStream

          @Deprecated
          protected final InputStream getUnicodeStream​(int columnIndex)
                                                throws SQLException

      Deprecated.
      Throws:
        `SQLException`

    - #### getUnicodeStream

          @Deprecated
          protected final InputStream getUnicodeStream​(String columnLabel)
                                                throws SQLException

      Deprecated.
      Throws:
        `SQLException`

    - #### getURL

          protected final URL getURL​(int columnIndex)
                              throws SQLException

      Throws:
        `SQLException`

    - #### getURL

          protected final URL getURL​(String columnLabel)
                              throws SQLException

      Throws:
        `SQLException`

    - #### getWarnings

          protected final SQLWarning getWarnings()
                                          throws SQLException

      Throws:
        `SQLException`

    - #### handle

          protected abstract T handle()
                               throws SQLException

      Turn the `ResultSet` into an Object.
      Returns:
        An Object initialized with `ResultSet` data
      Throws:
        `SQLException` - if a database access error occurs
      See Also:
        `ResultSetHandler.handle(ResultSet)`

    - #### handle

          public final T handle​(ResultSet rs)
                         throws SQLException

      Turn the `ResultSet` into an Object.
      Specified by:
        `handle` in interface `ResultSetHandler<T>`
      Parameters:
        `rs` - The `ResultSet` to handle. It has not been touched before being passed to this method.
      Returns:
        An Object initialized with `ResultSet` data. It is legal for implementations to return `null` if the `ResultSet` contained 0 rows.
      Throws:
        `SQLException` - if a database access error occurs

    - #### insertRow

          protected final void insertRow()
                                  throws SQLException

      Throws:
        `SQLException`

    - #### isAfterLast

          protected final boolean isAfterLast()
                                       throws SQLException

      Throws:
        `SQLException`

    - #### isBeforeFirst

          protected final boolean isBeforeFirst()
                                         throws SQLException

      Throws:
        `SQLException`

    - #### isClosed

          protected final boolean isClosed()
                                    throws SQLException

      Throws:
        `SQLException`

    - #### isFirst

          protected final boolean isFirst()
                                   throws SQLException

      Throws:
        `SQLException`

    - #### isLast

          protected final boolean isLast()
                                  throws SQLException

      Throws:
        `SQLException`

    - #### isWrapperFor

          protected final boolean isWrapperFor​(Class<?> iface)
                                        throws SQLException

      Throws:
        `SQLException`

    - #### last

          protected final boolean last()
                                throws SQLException

      Throws:
        `SQLException`

    - #### moveToCurrentRow

          protected final void moveToCurrentRow()
                                         throws SQLException

      Throws:
        `SQLException`

    - #### moveToInsertRow

          protected final void moveToInsertRow()
                                        throws SQLException

      Throws:
        `SQLException`

    - #### next

          protected final boolean next()
                                throws SQLException

      Throws:
        `SQLException`

    - #### previous

          protected final boolean previous()
                                    throws SQLException

      Throws:
        `SQLException`

    - #### refreshRow

          protected final void refreshRow()
                                   throws SQLException

      Throws:
        `SQLException`

    - #### relative

          protected final boolean relative​(int rows)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### rowDeleted

          protected final boolean rowDeleted()
                                      throws SQLException

      Throws:
        `SQLException`

    - #### rowInserted

          protected final boolean rowInserted()
                                       throws SQLException

      Throws:
        `SQLException`

    - #### rowUpdated

          protected final boolean rowUpdated()
                                      throws SQLException

      Throws:
        `SQLException`

    - #### setFetchDirection

          protected final void setFetchDirection​(int direction)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### setFetchSize

          protected final void setFetchSize​(int rows)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### unwrap

          protected final <E> E unwrap​(Class<E> iface)
                                throws SQLException

      Throws:
        `SQLException`

    - #### updateArray

          protected final void updateArray​(int columnIndex,
                                           Array x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateArray

          protected final void updateArray​(String columnLabel,
                                           Array x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateAsciiStream

          protected final void updateAsciiStream​(int columnIndex,
                                                 InputStream x)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### updateAsciiStream

          protected final void updateAsciiStream​(int columnIndex,
                                                 InputStream x,
                                                 int length)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### updateAsciiStream

          protected final void updateAsciiStream​(int columnIndex,
                                                 InputStream x,
                                                 long length)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### updateAsciiStream

          protected final void updateAsciiStream​(String columnLabel,
                                                 InputStream x)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### updateAsciiStream

          protected final void updateAsciiStream​(String columnLabel,
                                                 InputStream x,
                                                 int length)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### updateAsciiStream

          protected final void updateAsciiStream​(String columnLabel,
                                                 InputStream x,
                                                 long length)
                                          throws SQLException

      Throws:
        `SQLException`

    - #### updateBigDecimal

          protected final void updateBigDecimal​(int columnIndex,
                                                BigDecimal x)
                                         throws SQLException

      Throws:
        `SQLException`

    - #### updateBigDecimal

          protected final void updateBigDecimal​(String columnLabel,
                                                BigDecimal x)
                                         throws SQLException

      Throws:
        `SQLException`

    - #### updateBinaryStream

          protected final void updateBinaryStream​(int columnIndex,
                                                  InputStream x)
                                           throws SQLException

      Throws:
        `SQLException`

    - #### updateBinaryStream

          protected final void updateBinaryStream​(int columnIndex,
                                                  InputStream x,
                                                  int length)
                                           throws SQLException

      Throws:
        `SQLException`

    - #### updateBinaryStream

          protected final void updateBinaryStream​(int columnIndex,
                                                  InputStream x,
                                                  long length)
                                           throws SQLException

      Throws:
        `SQLException`

    - #### updateBinaryStream

          protected final void updateBinaryStream​(String columnLabel,
                                                  InputStream x)
                                           throws SQLException

      Throws:
        `SQLException`

    - #### updateBinaryStream

          protected final void updateBinaryStream​(String columnLabel,
                                                  InputStream x,
                                                  int length)
                                           throws SQLException

      Throws:
        `SQLException`

    - #### updateBinaryStream

          protected final void updateBinaryStream​(String columnLabel,
                                                  InputStream x,
                                                  long length)
                                           throws SQLException

      Throws:
        `SQLException`

    - #### updateBlob

          protected final void updateBlob​(int columnIndex,
                                          Blob x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateBlob

          protected final void updateBlob​(int columnIndex,
                                          InputStream inputStream)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateBlob

          protected final void updateBlob​(int columnIndex,
                                          InputStream inputStream,
                                          long length)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateBlob

          protected final void updateBlob​(String columnLabel,
                                          Blob x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateBlob

          protected final void updateBlob​(String columnLabel,
                                          InputStream inputStream)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateBlob

          protected final void updateBlob​(String columnLabel,
                                          InputStream inputStream,
                                          long length)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateBoolean

          protected final void updateBoolean​(int columnIndex,
                                             boolean x)
                                      throws SQLException

      Throws:
        `SQLException`

    - #### updateBoolean

          protected final void updateBoolean​(String columnLabel,
                                             boolean x)
                                      throws SQLException

      Throws:
        `SQLException`

    - #### updateByte

          protected final void updateByte​(int columnIndex,
                                          byte x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateByte

          protected final void updateByte​(String columnLabel,
                                          byte x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateBytes

          protected final void updateBytes​(int columnIndex,
                                           byte[] x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateBytes

          protected final void updateBytes​(String columnLabel,
                                           byte[] x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateCharacterStream

          protected final void updateCharacterStream​(int columnIndex,
                                                     Reader x)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### updateCharacterStream

          protected final void updateCharacterStream​(int columnIndex,
                                                     Reader x,
                                                     int length)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### updateCharacterStream

          protected final void updateCharacterStream​(int columnIndex,
                                                     Reader x,
                                                     long length)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### updateCharacterStream

          protected final void updateCharacterStream​(String columnLabel,
                                                     Reader reader)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### updateCharacterStream

          protected final void updateCharacterStream​(String columnLabel,
                                                     Reader reader,
                                                     int length)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### updateCharacterStream

          protected final void updateCharacterStream​(String columnLabel,
                                                     Reader reader,
                                                     long length)
                                              throws SQLException

      Throws:
        `SQLException`

    - #### updateClob

          protected final void updateClob​(int columnIndex,
                                          Clob x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateClob

          protected final void updateClob​(int columnIndex,
                                          Reader reader)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateClob

          protected final void updateClob​(int columnIndex,
                                          Reader reader,
                                          long length)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateClob

          protected final void updateClob​(String columnLabel,
                                          Clob x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateClob

          protected final void updateClob​(String columnLabel,
                                          Reader reader)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateClob

          protected final void updateClob​(String columnLabel,
                                          Reader reader,
                                          long length)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateDate

          protected final void updateDate​(int columnIndex,
                                          Date x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateDate

          protected final void updateDate​(String columnLabel,
                                          Date x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateDouble

          protected final void updateDouble​(int columnIndex,
                                            double x)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateDouble

          protected final void updateDouble​(String columnLabel,
                                            double x)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateFloat

          protected final void updateFloat​(int columnIndex,
                                           float x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateFloat

          protected final void updateFloat​(String columnLabel,
                                           float x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateInt

          protected final void updateInt​(int columnIndex,
                                         int x)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### updateInt

          protected final void updateInt​(String columnLabel,
                                         int x)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### updateLong

          protected final void updateLong​(int columnIndex,
                                          long x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateLong

          protected final void updateLong​(String columnLabel,
                                          long x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateNCharacterStream

          protected final void updateNCharacterStream​(int columnIndex,
                                                      Reader x)
                                               throws SQLException

      Throws:
        `SQLException`

    - #### updateNCharacterStream

          protected final void updateNCharacterStream​(int columnIndex,
                                                      Reader x,
                                                      long length)
                                               throws SQLException

      Throws:
        `SQLException`

    - #### updateNCharacterStream

          protected final void updateNCharacterStream​(String columnLabel,
                                                      Reader reader)
                                               throws SQLException

      Throws:
        `SQLException`

    - #### updateNCharacterStream

          protected final void updateNCharacterStream​(String columnLabel,
                                                      Reader reader,
                                                      long length)
                                               throws SQLException

      Throws:
        `SQLException`

    - #### updateNClob

          protected final void updateNClob​(int columnIndex,
                                           NClob nClob)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateNClob

          protected final void updateNClob​(int columnIndex,
                                           Reader reader)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateNClob

          protected final void updateNClob​(int columnIndex,
                                           Reader reader,
                                           long length)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateNClob

          protected final void updateNClob​(String columnLabel,
                                           NClob nClob)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateNClob

          protected final void updateNClob​(String columnLabel,
                                           Reader reader)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateNClob

          protected final void updateNClob​(String columnLabel,
                                           Reader reader,
                                           long length)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateNString

          protected final void updateNString​(int columnIndex,
                                             String nString)
                                      throws SQLException

      Throws:
        `SQLException`

    - #### updateNString

          protected final void updateNString​(String columnLabel,
                                             String nString)
                                      throws SQLException

      Throws:
        `SQLException`

    - #### updateNull

          protected final void updateNull​(int columnIndex)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateNull

          protected final void updateNull​(String columnLabel)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateObject

          protected final void updateObject​(int columnIndex,
                                            Object x)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateObject

          protected final void updateObject​(int columnIndex,
                                            Object x,
                                            int scaleOrLength)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateObject

          protected final void updateObject​(String columnLabel,
                                            Object x)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateObject

          protected final void updateObject​(String columnLabel,
                                            Object x,
                                            int scaleOrLength)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateRef

          protected final void updateRef​(int columnIndex,
                                         Ref x)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### updateRef

          protected final void updateRef​(String columnLabel,
                                         Ref x)
                                  throws SQLException

      Throws:
        `SQLException`

    - #### updateRow

          protected final void updateRow()
                                  throws SQLException

      Throws:
        `SQLException`

    - #### updateRowId

          protected final void updateRowId​(int columnIndex,
                                           RowId x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateRowId

          protected final void updateRowId​(String columnLabel,
                                           RowId x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateShort

          protected final void updateShort​(int columnIndex,
                                           short x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateShort

          protected final void updateShort​(String columnLabel,
                                           short x)
                                    throws SQLException

      Throws:
        `SQLException`

    - #### updateSQLXML

          protected final void updateSQLXML​(int columnIndex,
                                            SQLXML xmlObject)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateSQLXML

          protected final void updateSQLXML​(String columnLabel,
                                            SQLXML xmlObject)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateString

          protected final void updateString​(int columnIndex,
                                            String x)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateString

          protected final void updateString​(String columnLabel,
                                            String x)
                                     throws SQLException

      Throws:
        `SQLException`

    - #### updateTime

          protected final void updateTime​(int columnIndex,
                                          Time x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateTime

          protected final void updateTime​(String columnLabel,
                                          Time x)
                                   throws SQLException

      Throws:
        `SQLException`

    - #### updateTimestamp

          protected final void updateTimestamp​(int columnIndex,
                                               Timestamp x)
                                        throws SQLException

      Throws:
        `SQLException`

    - #### updateTimestamp

          protected final void updateTimestamp​(String columnLabel,
                                               Timestamp x)
                                        throws SQLException

      Throws:
        `SQLException`

    - #### wasNull

          protected final boolean wasNull()
                                   throws SQLException

      Throws:
        `SQLException`